# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/compat.ipynb.

# %% auto 0
__all__ = ['DataFrame', 'Series']

# %% ../nbs/compat.ipynb 1
from typing import Union

import pandas as pd

# %% ../nbs/compat.ipynb 2
try:
    from polars import DataFrame as pl_DataFrame
    from polars import Series as pl_Series
    from polars import col as pl_col
    from polars import concat as pl_concat
    from polars import lit as pl_lit

    POLARS_INSTALLED = True
except ImportError:

    class pl_DataFrame:  # type: ignore
        ...

    class pl_Series:  # type: ignore
        ...

    pl_col = None  # type: ignore
    pl_concat = None  # type: ignore
    pl_lit = None  # type: ignore

    POLARS_INSTALLED = False

try:
    import plotly  # noqa: F401

    PLOTLY_INSTALLED = True
except ImportError:
    PLOTLY_INSTALLED = False

try:
    import plotly_resampler  # noqa: F401

    PLOTLY_RESAMPLER_INSTALLED = True
except ImportError:
    PLOTLY_RESAMPLER_INSTALLED = False

DataFrame = Union[pd.DataFrame, pl_DataFrame]
Series = Union[pd.Series, pl_Series]
